package com.diagbot.facade;

import com.diagbot.biz.push.entity.Item;
import com.diagbot.biz.push.entity.Lis;
import com.diagbot.biz.push.entity.Pacs;
import com.diagbot.dto.BillNeoDTO;
import com.diagbot.dto.IndicationDTO;
import com.diagbot.dto.WordCrfDTO;
import com.diagbot.process.HighRiskProcess;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.BillNeoVO;
import com.diagbot.vo.IndicationPushVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @Description: 高风险合理性facade
 * @author: zhoutg
 * @time: 2018/8/6 9:11
 */
@Component
public class HighRiskFacade {

    @Autowired
    NeoFacade neoFacade;
    @Autowired
    HighRiskProcess highRiskProcess;
    @Autowired
    CommonFacade commonFacade;

    /**
     * 高风险业务
     * @param
     * @return
     */
    public void highRiskFac(IndicationPushVO indicationPushVO, WordCrfDTO wordCrfDTO, IndicationDTO res) {
        // 高风险图谱接口调用
        BillNeoVO billNeoVO = fillBillNeo(wordCrfDTO);
        List<BillNeoDTO> billNeoDTOList = neoFacade.getBillNeo(billNeoVO);

        // 规则处理
        highRiskProcess.process(billNeoDTOList, wordCrfDTO, res);
        System.out.println(res);
    }


    public BillNeoVO fillBillNeo(WordCrfDTO wordCrfDTO) {
        BillNeoVO billNeoVO = new BillNeoVO();

        List<Item> items = wordCrfDTO.getDrugOrder();

        for (Item item : items) {
            billNeoVO.getDrugList().put(item.getName(), item.getUniqueName());
        }

        List<Pacs> pacslist = wordCrfDTO.getPacsOrder();
        for (Pacs pacs : pacslist) {
            billNeoVO.getPacsList().put(pacs.getName(), pacs.getUniqueName());
        }

        List<Lis> lislist = wordCrfDTO.getLisOrder();
        for (Lis lis : lislist) {
            if (StringUtil.isBlank(lis.getDetailName())) {
                billNeoVO.getLisList().put(lis.getName(), lis.getUniqueName());
            }
            else {
                billNeoVO.getLisDetailList().put(lis.getDetailName(), lis.getUniqueName());
            }
        }

        List<Item> diags = wordCrfDTO.getDiagOrder();
        for (Item item : diags) {
            billNeoVO.getDiagList().put(item.getName(), item.getUniqueName());
        }

        return billNeoVO;
    }
}
